/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.47 Revision 1.119
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.47 2004/04/12 02:33:29 swtaylor Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.119 2007/05/12 11:45:51 vapier Exp $
4# 4#
5# Author Bart Verwilst <verwilst@gentoo.org> 5# Maintainer: toolchain@gentoo.org
6 6
7ECLASS=flag-o-matic 7# need access to emktemp()
8INHERITED="$INHERITED $ECLASS" 8inherit eutils toolchain-funcs multilib
9 9
10# 10#
11#### filter-flags <flags> #### 11#### filter-flags <flags> ####
12# Remove particular flags from C[XX]FLAGS 12# Remove particular flags from C[XX]FLAGS
13# Matches only complete flags 13# Matches only complete flags
16# Add extra flags to your current C[XX]FLAGS 16# Add extra flags to your current C[XX]FLAGS
17# 17#
18#### replace-flags <orig.flag> <new.flag> ### 18#### replace-flags <orig.flag> <new.flag> ###
19# Replace a flag by another one 19# Replace a flag by another one
20# 20#
21#### replace-cpu-flags <new.cpu> <old.cpus> ### 21#### replace-cpu-flags <old.cpus> <new.cpu> ###
22# Replace march/mcpu flags that specify <old.cpus> 22# Replace march/mcpu flags that specify <old.cpus>
23# with flags that specify <new.cpu> 23# with flags that specify <new.cpu>
24# 24#
25#### is-flag <flag> #### 25#### is-flag[q] <flag> ####
26# Returns "true" if flag is set in C[XX]FLAGS 26# Returns "true" if flag is set in C[XX]FLAGS
27# Matches only complete a flag 27# Matches only complete a flag
28# q version sets return code but doesn't echo
29#
30#### is-ldflag[q] <flag> ####
31# Returns "true" if flag is set in LDFLAGS
32# Matches only complete a flag
33# q version sets return code but doesn't echo
28# 34#
29#### strip-flags #### 35#### strip-flags ####
30# Strip C[XX]FLAGS of everything except known 36# Strip C[XX]FLAGS of everything except known
31# good options. 37# good options.
32# 38#
51# 57#
52#### filter-ldflags <flags> #### 58#### filter-ldflags <flags> ####
53# Remove particular flags from LDFLAGS 59# Remove particular flags from LDFLAGS
54# Matches only complete flags 60# Matches only complete flags
55# 61#
56#### etexec-flags #### 62#### bindnow-flags ####
57# hooked function for hardened-gcc that appends 63# Returns the flags to enable "now" binding in the current selected linker.
58# -yet_exec {C,CXX,LD}FLAGS when hardened-gcc is installed
59# and a package is filtering -fPIC,-fpic, -fPIE, -fpie
60# 64#
61#### fstack-flags #### 65################ DEPRECATED functions ################
62# hooked function for hardened-gcc that appends 66# The following are still present to avoid breaking existing
63# -yno_propolice to {C,CXX,LD}FLAGS when hardened-gcc is installed 67# code more than necessary; however they are deprecated. Please
64# and a package is filtering -fstack-protector, -fstack-protector-all 68# use gcc-specs-* from toolchain-funcs.eclass instead, if you
69# need to know which hardened techs are active in the compiler.
70# See bug #100974
71#
72#### has_hardened ####
73# Returns true if the compiler has 'Hardened' in its version string,
74# (note; switched-spec vanilla compilers satisfy this condition) or
75# the specs file name contains 'hardened'.
76#
77#### has_pie ####
78# Returns true if the compiler by default or with current CFLAGS
79# builds position-independent code.
80#
81#### has_pic ####
82# Returns true if the compiler by default or with current CFLAGS
83# builds position-independent code.
84#
85#### has_ssp_all ####
86# Returns true if the compiler by default or with current CFLAGS
87# generates stack smash protections for all functions
88#
89#### has_ssp ####
90# Returns true if the compiler by default or with current CFLAGS
91# generates stack smash protections for most vulnerable functions
65# 92#
66 93
67# C[XX]FLAGS that we allow in strip-flags 94# C[XX]FLAGS that we allow in strip-flags
95# Note: shell globs and character lists are allowed
68setup-allowed-flags() { 96setup-allowed-flags() {
69 if [ -z "${ALLOWED_FLAGS}" ] ; then 97 if [[ -z ${ALLOWED_FLAGS} ]] ; then
70 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -pipe -g" 98 export ALLOWED_FLAGS="-pipe"
71 case "${ARCH}" in 99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
72 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
73 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking"
74 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 102 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
75 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 103 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
76 esac 104 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
77 fi 105 fi
106 # allow a bunch of flags that negate features / control ABI
107 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
108 -fno-strict-aliasing -fno-bounds-checking"
109 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
110 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
111 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
112 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
113 -mieee -mieee-with-inexact -mschedule \
114 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
115 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
116 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
117 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
118 -msecure-plt -D*"
78 119
79 # C[XX]FLAGS that we are think is ok, but needs testing 120 # C[XX]FLAGS that we are think is ok, but needs testing
80 # NOTE: currently -Os have issues with gcc3 and K6* arch's 121 # NOTE: currently -Os have issues with gcc3 and K6* arch's
81 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 122 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
82 return 0 123 return 0
124}
125
126# inverted filters for hardened compiler. This is trying to unpick
127# the hardened compiler defaults.
128_filter-hardened() {
129 local f
130 for f in "$@" ; do
131 case "${f}" in
132 # Ideally we should only concern ourselves with PIE flags,
133 # not -fPIC or -fpic, but too many places filter -fPIC without
134 # thinking about -fPIE.
135 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
136 gcc-specs-pie || continue
137 is-flagq -nopie || append-flags -nopie;;
138 -fstack-protector)
139 gcc-specs-ssp || continue
140 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
141 -fstack-protector-all)
142 gcc-specs-ssp-to-all || continue
143 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
144 esac
145 done
146}
147
148# Remove occurrences of strings from variable given in $1
149# Strings removed are matched as globs, so for example
150# '-O*' would remove -O1, -O2 etc.
151_filter-var() {
152 local f x VAR VAL
153 declare -a new
154
155 VAR=$1
156 shift
157 eval VAL=\${${VAR}}
158 for f in ${VAL}; do
159 for x in "$@"; do
160 # Note this should work with globs like -O*
161 [[ ${f} == ${x} ]] && continue 2
162 done
163 eval new\[\${\#new\[@]}]=\${f}
164 done
165 eval export ${VAR}=\${new\[*]}
83} 166}
84 167
85filter-flags() { 168filter-flags() {
86 for x in "$@" ; do 169 _filter-hardened "$@"
87 case "${x}" in 170 _filter-var CFLAGS "$@"
88 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;; 171 _filter-var CPPFLAGS "$@"
89 -fstack-protector|-fstack-protector-all) fstack-flags;; 172 _filter-var CXXFLAGS "$@"
90 *) ;;
91 esac
92 done
93
94 # we do this fancy spacing stuff so as to not filter
95 # out part of a flag ... we want flag atoms ! :D
96 CFLAGS=" ${CFLAGS} "
97 CXXFLAGS=" ${CXXFLAGS} "
98 for x in "$@" ; do
99 CFLAGS="${CFLAGS// ${x} / }"
100 CXXFLAGS="${CXXFLAGS// ${x} / }"
101 done
102 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
103 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
104 return 0 173 return 0
105} 174}
106 175
107filter-lfs-flags() { 176filter-lfs-flags() {
177 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
108 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 178 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
109} 179}
110 180
181append-cppflags() {
182 [[ -z $* ]] && return 0
183 export CPPFLAGS="${CPPFLAGS} $*"
184 return 0
185}
186
187append-lfs-flags() {
188 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
189 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
190}
191
111append-flags() { 192append-flags() {
193 [[ -z $* ]] && return 0
112 export CFLAGS="${CFLAGS} $@" 194 export CFLAGS="${CFLAGS} $*"
113 export CXXFLAGS="${CXXFLAGS} $@" 195 export CXXFLAGS="${CXXFLAGS} $*"
114 [ "`is-flag -fno-stack-protector`" -o "`is-flag -fno-stack-protector-all`" ] && fstack-flags
115 return 0 196 return 0
116} 197}
117 198
118replace-flags() { 199replace-flags() {
119 # we do this fancy spacing stuff so as to not filter 200 [[ $# != 2 ]] \
120 # out part of a flag ... we want flag atoms ! :D 201 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
121 CFLAGS=" ${CFLAGS} " 202 && die "replace-flags takes 2 arguments, not $#"
122 CXXFLAGS=" ${CXXFLAGS} " 203
123 CFLAGS="${CFLAGS// ${1} / ${2} }" 204 local f fset
124 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }" 205 declare -a new_CFLAGS new_CXXFLAGS
125 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}" 206
126 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}" 207 for fset in CFLAGS CXXFLAGS; do
208 # Looping over the flags instead of using a global
209 # substitution ensures that we're working with flag atoms.
210 # Otherwise globs like -O* have the potential to wipe out the
211 # list of flags.
212 for f in ${!fset}; do
213 # Note this should work with globs like -O*
214 [[ ${f} == ${1} ]] && f=${2}
215 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
216 done
217 eval export ${fset}=\${new_${fset}\[*]}
218 done
219
127 return 0 220 return 0
128} 221}
129 222
130replace-cpu-flags() { 223replace-cpu-flags() {
131 local newcpu="$1" ; shift 224 local newcpu="$#" ; newcpu="${!newcpu}"
132 local oldcpu="" 225 while [ $# -gt 1 ] ; do
133 for oldcpu in "$@" ; do 226 # quote to make sure that no globbing is done (particularly on
227 # ${oldcpu}) prior to calling replace-flags
134 replace-flags -march=${oldcpu} -march=${newcpu} 228 replace-flags "-march=${1}" "-march=${newcpu}"
135 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 229 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
136 replace-flags -mtune=${oldcpu} -mtune=${newcpu} 230 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
231 shift
137 done 232 done
233 return 0
234}
235
236_is_flagq() {
237 local x
238 for x in ${!1} ; do
239 [[ ${x} == $2 ]] && return 0
240 done
138 return 0 241 return 1
242}
243
244is-flagq() {
245 [[ -n $2 ]] && die "Usage: is-flag <flag>"
246 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1
139} 247}
140 248
141is-flag() { 249is-flag() {
142 for x in ${CFLAGS} ${CXXFLAGS} ; do 250 is-flagq "$@" && echo true
143 if [ "${x}" == "$1" ] ; then 251}
144 echo true 252
145 return 0 253is-ldflagq() {
146 fi 254 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
147 done 255 _is_flagq LDFLAGS $1
148 return 1 256}
257
258is-ldflag() {
259 is-ldflagq "$@" && echo true
149} 260}
150 261
151filter-mfpmath() { 262filter-mfpmath() {
263 local orig_mfpmath new_math prune_math
264
152 # save the original -mfpmath flag 265 # save the original -mfpmath flag
153 local orig_mfpmath="`get-flag -mfpmath`" 266 orig_mfpmath=$(get-flag -mfpmath)
154 # get the value of the current -mfpmath flag 267 # get the value of the current -mfpmath flag
155 local new_math=" `get-flag mfpmath | tr , ' '` " 268 new_math=$(get-flag mfpmath)
269 new_math=" ${new_math//,/ } "
156 # figure out which math values are to be removed 270 # figure out which math values are to be removed
157 local prune_math="" 271 prune_math=""
158 for prune_math in "$@" ; do 272 for prune_math in "$@" ; do
159 new_math="${new_math/ ${prune_math} / }" 273 new_math=${new_math/ ${prune_math} / }
160 done 274 done
161 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 275 new_math=$(echo ${new_math})
276 new_math=${new_math// /,}
162 277
163 if [ -z "${new_math}" ] ; then 278 if [[ -z ${new_math} ]] ; then
164 # if we're removing all user specified math values are 279 # if we're removing all user specified math values are
165 # slated for removal, then we just filter the flag 280 # slated for removal, then we just filter the flag
166 filter-flags ${orig_mfpmath} 281 filter-flags ${orig_mfpmath}
167 else 282 else
168 # if we only want to filter some of the user specified 283 # if we only want to filter some of the user specified
171 fi 286 fi
172 return 0 287 return 0
173} 288}
174 289
175strip-flags() { 290strip-flags() {
291 local x y flag NEW_CFLAGS NEW_CXXFLAGS
292
176 setup-allowed-flags 293 setup-allowed-flags
177 294
178 local NEW_CFLAGS="" 295 local NEW_CFLAGS=""
179 local NEW_CXXFLAGS="" 296 local NEW_CXXFLAGS=""
180 297
181 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 298 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
182 if [ `has ~${ARCH} ${ACCEPT_KEYWORDS}` ] ; then 299 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
183 [ `use debug` ] && einfo "Enabling the use of some unstable flags"
184 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 300 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
185 fi 301 fi
186 302
187 set -f 303 set -f # disable pathname expansion
188 304
189 for x in ${CFLAGS} 305 for x in ${CFLAGS}; do
190 do
191 for y in ${ALLOWED_FLAGS} 306 for y in ${ALLOWED_FLAGS}; do
192 do
193 flag=${x%%=*} 307 flag=${x%%=*}
194 if [ "${flag%%${y}}" = "" ] 308 if [ "${flag%%${y}}" = "" ] ; then
195 then
196 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 309 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
197 break 310 break
198 fi 311 fi
199 done 312 done
200 done 313 done
201 314
202 for x in ${CXXFLAGS} 315 for x in ${CXXFLAGS}; do
203 do
204 for y in ${ALLOWED_FLAGS} 316 for y in ${ALLOWED_FLAGS}; do
205 do
206 flag=${x%%=*} 317 flag=${x%%=*}
207 if [ "${flag%%${y}}" = "" ] 318 if [ "${flag%%${y}}" = "" ] ; then
208 then
209 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 319 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
210 break 320 break
211 fi 321 fi
212 done 322 done
213 done 323 done
218 fi 328 fi
219 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 329 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
220 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 330 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
221 fi 331 fi
222 332
223 set +f 333 set +f # re-enable pathname expansion
224
225 [ `use debug` ] \
226 && einfo "CFLAGS=\"${NEW_CFLAGS}\"" \
227 && einfo "CXXFLAGS=\"${NEW_CXXFLAGS}\""
228 334
229 export CFLAGS="${NEW_CFLAGS}" 335 export CFLAGS="${NEW_CFLAGS}"
230 export CXXFLAGS="${NEW_CXXFLAGS}" 336 export CXXFLAGS="${NEW_CXXFLAGS}"
231 return 0 337 return 0
232} 338}
233 339
340test-flag-PROG() {
341 local comp=$1
342 local flags="$2"
343
344 [[ -z ${comp} || -z ${flags} ]] && \
345 return 1
346
347 local PROG=$(tc-get${comp})
348 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
349 > /dev/null 2>&1
350}
351
352# Returns true if C compiler support given flag
353test-flag-CC() { test-flag-PROG "CC" "$1"; }
354
355# Returns true if C++ compiler support given flag
356test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
357
358test-flags-PROG() {
359 local comp=$1
360 local flags
361 local x
362
363 shift
364
365 [[ -z ${comp} ]] && return 1
366
367 x=""
368 for x in "$@" ; do
369 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
370 done
371
372 echo "${flags}"
373
374 # Just bail if we dont have any flags
375 [[ -n ${flags} ]]
376}
377
378# Returns (echo's) the given flags supported by the C compiler
379test-flags-CC() { test-flags-PROG "CC" "$@"; }
380
381# Returns (echo's) the given flags supported by the C++ compiler
382test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
383
384# Short-hand that should hopefully work for both C and C++ compiler, but
385# its really only present due to the append-flags() abomination.
386test-flags() { test-flags-CC "$@"; }
387
388# Depriciated, use test-flags()
234test_flag() { 389test_flag() {
235 if [ -z "`gcc -S -xc "$@" -o /dev/null /dev/null 2>&1`" ]; then 390 ewarn "test_flag: deprecated, please use test-flags()!" >&2
236 echo "$@" 391
392 test-flags-CC "$@"
393}
394
395test_version_info() {
396 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
237 return 0 397 return 0
238 fi 398 else
239 return 1 399 return 1
400 fi
240} 401}
241 402
242strip-unsupported-flags() { 403strip-unsupported-flags() {
243 for x in ${CFLAGS} ; do 404 export CFLAGS=$(test-flags-CC ${CFLAGS})
244 NEW_CFLAGS=${NEW_CFLAGS}" ""`test_flag ${x}`" 405 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
245 done
246 for x in ${CXXFLAGS} ; do
247 NEW_CXXFLAGS=${NEW_CXXFLAGS}" ""`test_flag ${x}`"
248 done
249
250 export CFLAGS="${NEW_CFLAGS}"
251 export CXXFLAGS="${NEW_CXXFLAGS}"
252} 406}
253 407
254get-flag() { 408get-flag() {
409 local f findflag="$1"
410
255 # this code looks a little flaky but seems to work for 411 # this code looks a little flaky but seems to work for
256 # everything we want ... 412 # everything we want ...
257 # for example, if CFLAGS="-march=i686": 413 # for example, if CFLAGS="-march=i686":
258 # `get-flags -march` == "-march=i686" 414 # `get-flag -march` == "-march=i686"
259 # `get-flags march` == "i686" 415 # `get-flag march` == "i686"
260 local findflag="$1"
261 for f in ${CFLAGS} ${CXXFLAGS} ; do 416 for f in ${CFLAGS} ${CXXFLAGS} ; do
262 if [ "${f/${findflag}}" != "${f}" ] ; then 417 if [ "${f/${findflag}}" != "${f}" ] ; then
263 echo "${f/-${findflag}=}" 418 printf "%s\n" "${f/-${findflag}=}"
264 return 0 419 return 0
265 fi 420 fi
266 done 421 done
267 return 1 422 return 1
268} 423}
269 424
425# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
426has_hardened() {
427 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
428
429 test_version_info Hardened && return 0
430 # The specs file wont exist unless gcc has GCC_SPECS support
431 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
432}
433
434# DEPRECATED - use gcc-specs-pie from toolchain-funcs
435# indicate whether PIC is set
270has_pic() { 436has_pic() {
271 [ "${CFLAGS/-fPIC}" != "${CFLAGS}" ] && return 0 437 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
272 [ "${CFLAGS/-fpic}" != "${CFLAGS}" ] && return 0 438
273 has_version sys-devel/hardened-gcc && return 0 439 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
274 [ ! -z "`${CC/ .*/} --version| grep pie`" ] && return 0 440 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
441 gcc-specs-pie
442}
443
444# DEPRECATED - use gcc-specs-pie from toolchain-funcs
445# indicate whether PIE is set
446has_pie() {
447 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
448
449 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
450 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
451 gcc-specs-pie
452}
453
454# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
455# indicate whether code for SSP is being generated for all functions
456has_ssp_all() {
457 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
458
459 # note; this matches only -fstack-protector-all
460 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
461 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
462 gcc-specs-ssp-all
463}
464
465# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
466# indicate whether code for SSP is being generated
467has_ssp() {
468 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
469
470 # note; this matches both -fstack-protector and -fstack-protector-all
471 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
472 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
473 gcc-specs-ssp
474}
475
476has_m64() {
477 # this doesnt test if the flag is accepted, it tests if the flag
478 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
479 # please dont replace this function with test_flag in some future
480 # clean-up!
481
482 local temp="$(emktemp)"
483 echo "int main() { return(0); }" > "${temp}".c
484 MY_CC=$(tc-getCC)
485 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
486 local ret=$?
487 rm -f "${temp}".c
488 [[ ${ret} != 1 ]] && return 0
275 return 1 489 return 1
276} 490}
277 491
278has_pie() { 492has_m32() {
279 [ "${CFLAGS/-fPIE}" != "${CFLAGS}" ] && return 0 493 # this doesnt test if the flag is accepted, it tests if the flag
280 [ "${CFLAGS/-fpie}" != "${CFLAGS}" ] && return 0 494 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
281 has_version sys-devel/hardened-gcc && return 0 495 # please dont replace this function with test_flag in some future
282 [ ! -z "`${CC/ .*/} --version| grep pie`" ] && return 0 496 # clean-up!
497
498 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
499
500 local temp=$(emktemp)
501 echo "int main() { return(0); }" > "${temp}".c
502 MY_CC=$(tc-getCC)
503 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
504 local ret=$?
505 rm -f "${temp}".c
506 [[ ${ret} != 1 ]] && return 0
283 return 1 507 return 1
284} 508}
285
286has_ssp() {
287 [ "${CFLAGS/-fstack-protector}" != "${CFLAGS}" ] && return 0
288 has_version sys-devel/hardened-gcc && return 0
289 [ ! -z "`${CC/ .*/} --version| grep ssp`" ] && return 0
290 return 1
291}
292 509
293replace-sparc64-flags() { 510replace-sparc64-flags() {
294 local SPARC64_CPUS="ultrasparc v9" 511 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
295 512
296 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ] 513 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
297 then
298 for x in ${SPARC64_CPUS} 514 for x in ${SPARC64_CPUS}; do
299 do
300 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 515 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
301 done 516 done
302 else 517 else
303 for x in ${SPARC64_CPUS} 518 for x in ${SPARC64_CPUS}; do
304 do
305 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 519 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
306 done 520 done
307 fi 521 fi
308 522
309 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ] 523 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
310 then
311 for x in ${SPARC64_CPUS} 524 for x in ${SPARC64_CPUS}; do
312 do
313 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 525 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
314 done 526 done
315 else 527 else
316 for x in ${SPARC64_CPUS} 528 for x in ${SPARC64_CPUS}; do
317 do
318 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 529 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
319 done 530 done
320 fi 531 fi
532
533 export CFLAGS CXXFLAGS
321} 534}
322 535
323append-ldflags() { 536append-ldflags() {
537 [[ -z $* ]] && return 0
324 LDFLAGS="${LDFLAGS} $@" 538 export LDFLAGS="${LDFLAGS} $*"
325 return 0 539 return 0
326} 540}
327 541
542# Remove flags from LDFLAGS - it's up to the ebuild to filter
543# CFLAGS and CXXFLAGS via filter-flags if they need to.
328filter-ldflags() { 544filter-ldflags() {
329 # we do this fancy spacing stuff so as to not filter 545 _filter-var LDFLAGS "$@"
330 # out part of a flag ... we want flag atoms ! :D 546 return 0
331 LDFLAGS=" ${LDFLAGS} " 547}
548
549# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
550# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
551# to gcc where it needs the '-Wl,'.
552raw-ldflags() {
553 local x input="$@"
554 [[ -z ${input} ]] && input=${LDFLAGS}
555 set --
332 for x in "$@" ; do 556 for x in ${input} ; do
333 LDFLAGS="${LDFLAGS// ${x} / }" 557 x=${x#-Wl,}
558 set -- "$@" ${x//,/ }
334 done 559 done
335 LDFLAGS="${LDFLAGS:1:${#LDFLAGS}-2}" 560 echo "$@"
336 return 0
337} 561}
338 562
339etexec-flags() { 563# Gets the flags needed for "NOW" binding
340 has_pie || has_pic 564bindnow-flags() {
341 if [ $? == 0 ] ; then 565 case $($(tc-getLD) -v 2>&1 </dev/null) in
342 [ -z "`is-flag -yet_exec`" ] && 566 *GNU* | *'with BFD'*) # GNU ld
343 export CFLAGS="${CFLAGS} `test_flag -yet_exec`" 567 echo "-Wl,-z,now" ;;
344 [ -z "`is-flag -nopie`" ] && 568 *Apple*) # Darwin ld
345 export CFLAGS="${CFLAGS} `test_flag -nopie`" 569 echo "-bind_at_load" ;;
346 fi 570 *)
571 # Some linkers just recognize -V instead of -v
572 case $($(tc-getLD) -V 2>&1 </dev/null) in
573 *Solaris*) # Solaris accept almost the same GNU options
574 echo "-Wl,-z,now" ;;
575 esac
576 ;;
577 esac
347} 578}
348 579
349fstack-flags() { 580
350 has_ssp 581# Some tests for when we screw with things and want to make
351 if [ $? == 0 ] ; then 582# sure we didn't break anything
352 [ -z "`is-flag -yno_propolice`" ] && 583#TESTS() {
353 export CFLAGS="${CFLAGS} `test_flag -fno-stack-protector`" 584# CFLAGS="-a -b -c=1"
354 fi 585# CXXFLAGS="-x -y -z=2"
355} 586# LDFLAGS="-l -m -n=3"
587#
588# die() { exit 1; }
589# (is-flag 1 2 3) && die
590# (is-ldflag 1 2 3) && die
591#
592# is-flagq -l && die
593# is-ldflagq -a && die
594# is-flagq -a || die
595# is-flagq -x || die
596# is-ldflagq -n=* || die
597# is-ldflagq -n && die
598#
599# strip-unsupported-flags
600# [[ ${CFLAGS} == "-c=1" ]] || die
601# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
602#
603# echo "All tests pass"
604#}
605#TESTS

Legend:
Removed from v.1.47  
changed lines
  Added in v.1.119

  ViewVC Help
Powered by ViewVC 1.1.20